## HTTP File Upload

[HTTP File Upload](https://xmpp.org/extensions/xep-0363.html) specification older than 0.3.0 is no longer supported, i.e. the one namespaced with `urn:xmpp:http:upload`.
Currently, only the `urn:xmpp:http:upload:0` XMLNS is served.

All major, modern client libraries and applications support the 0.3.0+ specification.
If you experience any issues with making requests to the HTTP File Upload service, please update your client.

## Retirement of the old `*.cfg` format

Since release 4.1.0, we are no longer supporting the `*.cfg` MongooseIM configuration format. Please use the `TOML` format instead.

## Minor changes in the `TOML` config format

* [`mod_bosh.max_pause`](../modules/mod_bosh.md#modulesmod_boshmax_pause) instead of `maxpause`

* [`mod_disco.server_info.module`](../modules/mod_disco.md#modulesmod_discoserver_info): the field is optional, no longer required

* [`mod_global_distrib.connections.advertised_endpoints`](../modules/mod_global_distrib.md#modulesmod_global_distribconnectionsadvertised_endpoints): default not set (`false` is no longer accepted)

* `mod_global_distrib.connections.tls.enabled`: the flag was removed, TLS is enabled by providing the [`cacertfile`](../modules/mod_global_distrib.md#modulesmod_global_distribconnectionstlscacertfile) and [`certfile`](../modules/mod_global_distrib.md#modulesmod_global_distribconnectionstlscertfile) options

* [`mod_http_upload.max_file_size`](../modules/mod_http_upload.md#modulesmod_http_uploadmax_file_size): `undefined` is no longer allowed

* [`mod_mam_meta.user_prefs_store`](../modules/mod_mam.md#modulesmod_mamuser_prefs_store): `false` is no longer allowed (note: the module is called `mod_mam` in the most recent versions)

* [`mod_muc_light.config_schema`](../modules/mod_muc_light.md#modulesmod_muc_lightconfig_schema): the usage of `value` and `type` fields was replaced with one of the following fields: `string_value`, `integer_value` or `float_value`

* [`mod_muc_log.css_file`](../modules/mod_muc_log.md#modulesmod_muc_logcss_file): the default value was changed from `"false"` to `not set`

* `mod_stream_management`: minor adjustments of [`buffer_max`](../modules/mod_stream_management.md#modulesmod_stream_managementbuffer_max) and [`ack_freq`](../modules/mod_stream_management.md#modulesmod_stream_managementack_freq) options, [`buffer`](../modules/mod_stream_management.md#modulesmod_stream_managementbuffer) and [`ack`](../modules/mod_stream_management.md#modulesmod_stream_managementack) booleans were added

* [`listen.c2s.tls.ciphers`](../listeners/listen-c2s.md#listenc2stlsciphers), [`listen.http.tls.ciphers`](../listeners/listen-http.md#tls-https-options) and [`outgoing_pools.*.*.connection.tls.ciphers`](../configuration/outgoing-connections.md#outgoing_poolsconnectiontlsciphers): the ciphers should now be formatted as a specification string

* [`listen.http.handlers.mod_websockets.ping_rate`](../listeners/listen-http.md#listenhttphandlersmod_websocketsping_rate): `none` is no longer allowed
